!
!  int_10d.f90: Ten dimensional integration using Monte-Carlo
!
!  taken from: "Projects in Computational Physics" by Landau and Paez  
!	       copyrighted by John Wiley and Sons, New York        
!                                                                
!  written by: students in PH465/565, Computational Physics,    
!	       at Oregon State University                       
!              code copyrighted by RH Landau                  
!  supported by: US National Science Foundation, Northwest Alliance 
!                for Computational Science and Engineering (NACSE),
!                US Department of Energy 	                       
!								       
!
!  modified for SUN Sunstudio F95 compiler: Ch. Elster, September 2008
!
!    			                                        
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 

      program int10d

      implicit none

      integer :: nmax
      parameter (nmax=1000)
   
      integer :: i, j, iflag, n, nsave 
      double precision :: drand, x, y, seed, ys(nmax)

      integer :: kread, kwrite
      data kread/5/, kwrite/6/


      open(kwrite, File='int_10d.dat', Status='Unknown')

!        initialize

      n=0

      iflag = 1
      seed = drand(iflag)
      iflag=0

!        Outer loops determines the number of trials = accuracy


      do i=1, nmax

      x=0.d0
!
!        Add up ten random numbers x1 .. x10

      do  j=1,10
         x=x+drand(iflag)
      end do 

!        square and add up

      y=y+x*x

!        save result for 2,4,8,16 .....

      if (mod(i,2**n) .eq. 0) then
         n=n+1
         ys(n)=y/dble(i)
         write (kwrite,*) i, ys(n)
      endif

      nsave=n
 
      end do 
      close(kwrite)
      
      stop 'data saved in int_10d.dat'
      end
